module op_sharing_ex1b 
#(
   parameter N = 4
)(
   input          s,
   input  [N-1:0] a, b, c, d,
   output [N-1:0] f,
   output         ov
);

reg  [N-1:0] src0, src1;
wire [N:0]   tmp;

always @* begin
   if (s) begin
      src0 = a;
      src1 = b;
   end
   else begin
      src0 = c;
      src1 = d;
   end
end

assign tmp = src0 + src1;
assign f = tmp[N-1:0];
assign ov = tmp[N];

endmodule