module op_sharing_ex1a 
#(
   parameter N = 4
)(
   input          s,
   input  [N-1:0] a, b, c, d,
   output [N-1:0] f,
   output         ov
);

reg [N:0] tmp;

always @* begin
   if (s)
      tmp = a+b;
   else
      tmp = c+d;
end

assign f = tmp[N-1:0];
assign ov = tmp[N];

endmodule